"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// meta.ts
var meta_exports = {};
__export(meta_exports, {
  bulkCreateBillableItems: () => bulkCreateBillableItems2,
  bulkDeleteBillableItems: () => bulkDeleteBillableItems2,
  bulkUpdateBillableItemTags: () => bulkUpdateBillableItemTags2,
  bulkUpdateBillableItemTagsByFilter: () => bulkUpdateBillableItemTagsByFilter2,
  bulkUpdateBillableItems: () => bulkUpdateBillableItems2,
  createBillableItem: () => createBillableItem2,
  deleteBillableItem: () => deleteBillableItem2,
  getBillableItem: () => getBillableItem2,
  queryBillableItems: () => queryBillableItems2,
  searchBillableItems: () => searchBillableItems2,
  updateBillableItem: () => updateBillableItem2
});
module.exports = __toCommonJS(meta_exports);

// src/billable-items-v1-billable-item-billable-items.http.ts
var import_rest_modules = require("@wix/sdk-runtime/rest-modules");
var import_float = require("@wix/sdk-runtime/transformations/float");
var import_float2 = require("@wix/sdk-runtime/transformations/float");
var import_timestamp = require("@wix/sdk-runtime/transformations/timestamp");
var import_timestamp2 = require("@wix/sdk-runtime/transformations/timestamp");
var import_field_mask = require("@wix/sdk-runtime/transformations/field-mask");
var import_transform_paths = require("@wix/sdk-runtime/transformations/transform-paths");
var import_rest_modules2 = require("@wix/sdk-runtime/rest-modules");
function resolveWixBillableItemsV1BillableItemsUrl(opts) {
  const domainToMappings = {
    "manage._base_domain_": [
      {
        srcPath: "/_api/billable-items",
        destPath: ""
      }
    ],
    "www.wixapis.com": [
      {
        srcPath: "/billable-items/v1/billable-items",
        destPath: "/v1/billable-items"
      }
    ]
  };
  return (0, import_rest_modules2.resolveUrl)(Object.assign(opts, { domainToMappings }));
}
var PACKAGE_NAME = "@wix/auto_sdk_get-paid_billable-items";
function createBillableItem(payload) {
  function __createBillableItem({ host }) {
    const serializedData = (0, import_transform_paths.transformPaths)(payload, [
      {
        transformFn: import_timestamp.transformSDKTimestampToRESTTimestamp,
        paths: [
          { path: "billableItem.createdDate" },
          { path: "billableItem.updatedDate" }
        ]
      }
    ]);
    const metadata = {
      entityFqdn: "wix.billable_items.v1.billable_item",
      method: "POST",
      methodFqn: "wix.billable_items.v1.BillableItems.CreateBillableItem",
      packageName: PACKAGE_NAME,
      url: resolveWixBillableItemsV1BillableItemsUrl({
        protoPath: "/v1/billable-items",
        data: serializedData,
        host
      }),
      data: serializedData,
      transformResponse: (payload2) => (0, import_transform_paths.transformPaths)(payload2, [
        {
          transformFn: import_timestamp2.transformRESTTimestampToSDKTimestamp,
          paths: [
            { path: "billableItem.createdDate" },
            { path: "billableItem.updatedDate" }
          ]
        }
      ])
    };
    return metadata;
  }
  return __createBillableItem;
}
function getBillableItem(payload) {
  function __getBillableItem({ host }) {
    const metadata = {
      entityFqdn: "wix.billable_items.v1.billable_item",
      method: "GET",
      methodFqn: "wix.billable_items.v1.BillableItems.GetBillableItem",
      packageName: PACKAGE_NAME,
      url: resolveWixBillableItemsV1BillableItemsUrl({
        protoPath: "/v1/billable-items/{billableItemId}",
        data: payload,
        host
      }),
      params: (0, import_rest_modules.toURLSearchParams)(payload),
      transformResponse: (payload2) => (0, import_transform_paths.transformPaths)(payload2, [
        {
          transformFn: import_timestamp2.transformRESTTimestampToSDKTimestamp,
          paths: [
            { path: "billableItem.createdDate" },
            { path: "billableItem.updatedDate" }
          ]
        }
      ])
    };
    return metadata;
  }
  return __getBillableItem;
}
function updateBillableItem(payload) {
  function __updateBillableItem({ host }) {
    const serializedData = (0, import_transform_paths.transformPaths)(payload, [
      {
        transformFn: import_field_mask.transformSDKFieldMaskToRESTFieldMask,
        paths: [{ path: "fieldMask" }]
      },
      {
        transformFn: import_timestamp.transformSDKTimestampToRESTTimestamp,
        paths: [
          { path: "billableItem.createdDate" },
          { path: "billableItem.updatedDate" }
        ]
      }
    ]);
    const metadata = {
      entityFqdn: "wix.billable_items.v1.billable_item",
      method: "PATCH",
      methodFqn: "wix.billable_items.v1.BillableItems.UpdateBillableItem",
      packageName: PACKAGE_NAME,
      url: resolveWixBillableItemsV1BillableItemsUrl({
        protoPath: "/v1/billable-items/{billableItem.id}",
        data: serializedData,
        host
      }),
      data: serializedData,
      transformResponse: (payload2) => (0, import_transform_paths.transformPaths)(payload2, [
        {
          transformFn: import_timestamp2.transformRESTTimestampToSDKTimestamp,
          paths: [
            { path: "billableItem.createdDate" },
            { path: "billableItem.updatedDate" }
          ]
        }
      ])
    };
    return metadata;
  }
  return __updateBillableItem;
}
function deleteBillableItem(payload) {
  function __deleteBillableItem({ host }) {
    const metadata = {
      entityFqdn: "wix.billable_items.v1.billable_item",
      method: "DELETE",
      methodFqn: "wix.billable_items.v1.BillableItems.DeleteBillableItem",
      packageName: PACKAGE_NAME,
      url: resolveWixBillableItemsV1BillableItemsUrl({
        protoPath: "/v1/billable-items/{billableItemId}",
        data: payload,
        host
      }),
      params: (0, import_rest_modules.toURLSearchParams)(payload)
    };
    return metadata;
  }
  return __deleteBillableItem;
}
function queryBillableItems(payload) {
  function __queryBillableItems({ host }) {
    const metadata = {
      entityFqdn: "wix.billable_items.v1.billable_item",
      method: "POST",
      methodFqn: "wix.billable_items.v1.BillableItems.QueryBillableItems",
      packageName: PACKAGE_NAME,
      url: resolveWixBillableItemsV1BillableItemsUrl({
        protoPath: "/v1/billable-items/query",
        data: payload,
        host
      }),
      data: payload,
      transformResponse: (payload2) => (0, import_transform_paths.transformPaths)(payload2, [
        {
          transformFn: import_timestamp2.transformRESTTimestampToSDKTimestamp,
          paths: [
            { path: "billableItems.createdDate" },
            { path: "billableItems.updatedDate" }
          ]
        }
      ]),
      fallback: [
        {
          method: "POST",
          url: resolveWixBillableItemsV1BillableItemsUrl({
            protoPath: "/v1/billable-items/query",
            data: payload,
            host
          }),
          data: payload
        }
      ]
    };
    return metadata;
  }
  return __queryBillableItems;
}
function bulkCreateBillableItems(payload) {
  function __bulkCreateBillableItems({ host }) {
    const serializedData = (0, import_transform_paths.transformPaths)(payload, [
      {
        transformFn: import_timestamp.transformSDKTimestampToRESTTimestamp,
        paths: [
          { path: "billableItems.createdDate" },
          { path: "billableItems.updatedDate" }
        ]
      }
    ]);
    const metadata = {
      entityFqdn: "wix.billable_items.v1.billable_item",
      method: "POST",
      methodFqn: "wix.billable_items.v1.BillableItems.BulkCreateBillableItems",
      packageName: PACKAGE_NAME,
      url: resolveWixBillableItemsV1BillableItemsUrl({
        protoPath: "/v1/bulk/billable-items/create",
        data: serializedData,
        host
      }),
      data: serializedData,
      transformResponse: (payload2) => (0, import_transform_paths.transformPaths)(payload2, [
        {
          transformFn: import_timestamp2.transformRESTTimestampToSDKTimestamp,
          paths: [
            { path: "results.item.createdDate" },
            { path: "results.item.updatedDate" }
          ]
        }
      ])
    };
    return metadata;
  }
  return __bulkCreateBillableItems;
}
function bulkUpdateBillableItems(payload) {
  function __bulkUpdateBillableItems({ host }) {
    const serializedData = (0, import_transform_paths.transformPaths)(payload, [
      {
        transformFn: import_field_mask.transformSDKFieldMaskToRESTFieldMask,
        paths: [{ path: "billableItems.fieldMask" }]
      },
      {
        transformFn: import_timestamp.transformSDKTimestampToRESTTimestamp,
        paths: [
          { path: "billableItems.billableItem.createdDate" },
          { path: "billableItems.billableItem.updatedDate" }
        ]
      }
    ]);
    const metadata = {
      entityFqdn: "wix.billable_items.v1.billable_item",
      method: "POST",
      methodFqn: "wix.billable_items.v1.BillableItems.BulkUpdateBillableItems",
      packageName: PACKAGE_NAME,
      url: resolveWixBillableItemsV1BillableItemsUrl({
        protoPath: "/v1/bulk/billable-items/update",
        data: serializedData,
        host
      }),
      data: serializedData,
      transformResponse: (payload2) => (0, import_transform_paths.transformPaths)(payload2, [
        {
          transformFn: import_timestamp2.transformRESTTimestampToSDKTimestamp,
          paths: [
            { path: "results.item.createdDate" },
            { path: "results.item.updatedDate" }
          ]
        }
      ])
    };
    return metadata;
  }
  return __bulkUpdateBillableItems;
}
function bulkDeleteBillableItems(payload) {
  function __bulkDeleteBillableItems({ host }) {
    const metadata = {
      entityFqdn: "wix.billable_items.v1.billable_item",
      method: "POST",
      methodFqn: "wix.billable_items.v1.BillableItems.BulkDeleteBillableItems",
      packageName: PACKAGE_NAME,
      url: resolveWixBillableItemsV1BillableItemsUrl({
        protoPath: "/v1/bulk/billable-items/delete",
        data: payload,
        host
      }),
      data: payload
    };
    return metadata;
  }
  return __bulkDeleteBillableItems;
}
function bulkUpdateBillableItemTags(payload) {
  function __bulkUpdateBillableItemTags({ host }) {
    const metadata = {
      entityFqdn: "wix.billable_items.v1.billable_item",
      method: "POST",
      methodFqn: "wix.billable_items.v1.BillableItems.BulkUpdateBillableItemTags",
      packageName: PACKAGE_NAME,
      url: resolveWixBillableItemsV1BillableItemsUrl({
        protoPath: "/v1/bulk/billable-items/update-tags",
        data: payload,
        host
      }),
      data: payload
    };
    return metadata;
  }
  return __bulkUpdateBillableItemTags;
}
function bulkUpdateBillableItemTagsByFilter(payload) {
  function __bulkUpdateBillableItemTagsByFilter({ host }) {
    const metadata = {
      entityFqdn: "wix.billable_items.v1.billable_item",
      method: "POST",
      methodFqn: "wix.billable_items.v1.BillableItems.BulkUpdateBillableItemTagsByFilter",
      packageName: PACKAGE_NAME,
      url: resolveWixBillableItemsV1BillableItemsUrl({
        protoPath: "/v1/bulk/billable-items/update-tags-by-filter",
        data: payload,
        host
      }),
      data: payload
    };
    return metadata;
  }
  return __bulkUpdateBillableItemTagsByFilter;
}
function searchBillableItems(payload) {
  function __searchBillableItems({ host }) {
    const serializedData = (0, import_transform_paths.transformPaths)(payload, [
      {
        transformFn: import_float.transformSDKFloatToRESTFloat,
        paths: [
          { path: "search.aggregations.range.buckets.from" },
          { path: "search.aggregations.range.buckets.to" },
          {
            path: "search.aggregations.nested.nestedAggregations.range.buckets.from"
          },
          {
            path: "search.aggregations.nested.nestedAggregations.range.buckets.to"
          }
        ]
      }
    ]);
    const metadata = {
      entityFqdn: "wix.billable_items.v1.billable_item",
      method: "POST",
      methodFqn: "wix.billable_items.v1.BillableItems.SearchBillableItems",
      packageName: PACKAGE_NAME,
      url: resolveWixBillableItemsV1BillableItemsUrl({
        protoPath: "/v1/billable-items/search",
        data: serializedData,
        host
      }),
      data: serializedData,
      transformResponse: (payload2) => (0, import_transform_paths.transformPaths)(payload2, [
        {
          transformFn: import_timestamp2.transformRESTTimestampToSDKTimestamp,
          paths: [
            { path: "billableItems.createdDate" },
            { path: "billableItems.updatedDate" }
          ]
        },
        {
          transformFn: import_float2.transformRESTFloatToSDKFloat,
          paths: [
            { path: "aggregationData.results.ranges.results.from" },
            { path: "aggregationData.results.ranges.results.to" },
            {
              path: "aggregationData.results.groupedByValue.results.nestedResults.ranges.results.from"
            },
            {
              path: "aggregationData.results.groupedByValue.results.nestedResults.ranges.results.to"
            },
            {
              path: "aggregationData.results.nested.results.results.*.range.from"
            },
            {
              path: "aggregationData.results.nested.results.results.*.range.to"
            },
            { path: "aggregationData.results.scalar.value" },
            {
              path: "aggregationData.results.groupedByValue.results.nestedResults.scalar.value"
            },
            {
              path: "aggregationData.results.nested.results.results.*.scalar.value"
            }
          ]
        }
      ])
    };
    return metadata;
  }
  return __searchBillableItems;
}

// src/billable-items-v1-billable-item-billable-items.meta.ts
function createBillableItem2() {
  const payload = {};
  const getRequestOptions = createBillableItem(payload);
  const getUrl = (context) => {
    const { url } = getRequestOptions(context);
    return url;
  };
  return {
    getUrl,
    httpMethod: "POST",
    path: "/v1/billable-items",
    pathParams: {},
    __requestType: null,
    __originalRequestType: null,
    __responseType: null,
    __originalResponseType: null
  };
}
function getBillableItem2() {
  const payload = { billableItemId: ":billableItemId" };
  const getRequestOptions = getBillableItem(payload);
  const getUrl = (context) => {
    const { url } = getRequestOptions(context);
    return url;
  };
  return {
    getUrl,
    httpMethod: "GET",
    path: "/v1/billable-items/{billableItemId}",
    pathParams: { billableItemId: "billableItemId" },
    __requestType: null,
    __originalRequestType: null,
    __responseType: null,
    __originalResponseType: null
  };
}
function updateBillableItem2() {
  const payload = { billableItem: { id: ":billableItemId" } };
  const getRequestOptions = updateBillableItem(payload);
  const getUrl = (context) => {
    const { url } = getRequestOptions(context);
    return url;
  };
  return {
    getUrl,
    httpMethod: "PATCH",
    path: "/v1/billable-items/{billableItem.id}",
    pathParams: { billableItemId: "billableItemId" },
    __requestType: null,
    __originalRequestType: null,
    __responseType: null,
    __originalResponseType: null
  };
}
function deleteBillableItem2() {
  const payload = { billableItemId: ":billableItemId" };
  const getRequestOptions = deleteBillableItem(payload);
  const getUrl = (context) => {
    const { url } = getRequestOptions(context);
    return url;
  };
  return {
    getUrl,
    httpMethod: "DELETE",
    path: "/v1/billable-items/{billableItemId}",
    pathParams: { billableItemId: "billableItemId" },
    __requestType: null,
    __originalRequestType: null,
    __responseType: null,
    __originalResponseType: null
  };
}
function queryBillableItems2() {
  const payload = {};
  const getRequestOptions = queryBillableItems(payload);
  const getUrl = (context) => {
    const { url } = getRequestOptions(context);
    return url;
  };
  return {
    getUrl,
    httpMethod: "GET",
    path: "/v1/billable-items/query",
    pathParams: {},
    __requestType: null,
    __originalRequestType: null,
    __responseType: null,
    __originalResponseType: null
  };
}
function bulkCreateBillableItems2() {
  const payload = {};
  const getRequestOptions = bulkCreateBillableItems(payload);
  const getUrl = (context) => {
    const { url } = getRequestOptions(context);
    return url;
  };
  return {
    getUrl,
    httpMethod: "POST",
    path: "/v1/bulk/billable-items/create",
    pathParams: {},
    __requestType: null,
    __originalRequestType: null,
    __responseType: null,
    __originalResponseType: null
  };
}
function bulkUpdateBillableItems2() {
  const payload = {};
  const getRequestOptions = bulkUpdateBillableItems(payload);
  const getUrl = (context) => {
    const { url } = getRequestOptions(context);
    return url;
  };
  return {
    getUrl,
    httpMethod: "POST",
    path: "/v1/bulk/billable-items/update",
    pathParams: {},
    __requestType: null,
    __originalRequestType: null,
    __responseType: null,
    __originalResponseType: null
  };
}
function bulkDeleteBillableItems2() {
  const payload = {};
  const getRequestOptions = bulkDeleteBillableItems(payload);
  const getUrl = (context) => {
    const { url } = getRequestOptions(context);
    return url;
  };
  return {
    getUrl,
    httpMethod: "POST",
    path: "/v1/bulk/billable-items/delete",
    pathParams: {},
    __requestType: null,
    __originalRequestType: null,
    __responseType: null,
    __originalResponseType: null
  };
}
function bulkUpdateBillableItemTags2() {
  const payload = {};
  const getRequestOptions = bulkUpdateBillableItemTags(
    payload
  );
  const getUrl = (context) => {
    const { url } = getRequestOptions(context);
    return url;
  };
  return {
    getUrl,
    httpMethod: "POST",
    path: "/v1/bulk/billable-items/update-tags",
    pathParams: {},
    __requestType: null,
    __originalRequestType: null,
    __responseType: null,
    __originalResponseType: null
  };
}
function bulkUpdateBillableItemTagsByFilter2() {
  const payload = {};
  const getRequestOptions = bulkUpdateBillableItemTagsByFilter(
    payload
  );
  const getUrl = (context) => {
    const { url } = getRequestOptions(context);
    return url;
  };
  return {
    getUrl,
    httpMethod: "POST",
    path: "/v1/bulk/billable-items/update-tags-by-filter",
    pathParams: {},
    __requestType: null,
    __originalRequestType: null,
    __responseType: null,
    __originalResponseType: null
  };
}
function searchBillableItems2() {
  const payload = {};
  const getRequestOptions = searchBillableItems(payload);
  const getUrl = (context) => {
    const { url } = getRequestOptions(context);
    return url;
  };
  return {
    getUrl,
    httpMethod: "POST",
    path: "/v1/billable-items/search",
    pathParams: {},
    __requestType: null,
    __originalRequestType: null,
    __responseType: null,
    __originalResponseType: null
  };
}
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  bulkCreateBillableItems,
  bulkDeleteBillableItems,
  bulkUpdateBillableItemTags,
  bulkUpdateBillableItemTagsByFilter,
  bulkUpdateBillableItems,
  createBillableItem,
  deleteBillableItem,
  getBillableItem,
  queryBillableItems,
  searchBillableItems,
  updateBillableItem
});
//# sourceMappingURL=meta.js.map