"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// index.ts
var index_exports = {};
__export(index_exports, {
  AggregationType: () => AggregationType,
  Interval: () => Interval,
  MissingValues: () => MissingValues,
  Mode: () => Mode,
  NestedAggregationType: () => NestedAggregationType,
  ScalarType: () => ScalarType,
  SortDirection: () => SortDirection,
  SortOrder: () => SortOrder,
  SortType: () => SortType,
  WebhookIdentityType: () => WebhookIdentityType,
  bulkCreateBillableItems: () => bulkCreateBillableItems4,
  bulkDeleteBillableItems: () => bulkDeleteBillableItems4,
  bulkUpdateBillableItemTags: () => bulkUpdateBillableItemTags4,
  bulkUpdateBillableItemTagsByFilter: () => bulkUpdateBillableItemTagsByFilter4,
  bulkUpdateBillableItems: () => bulkUpdateBillableItems4,
  createBillableItem: () => createBillableItem4,
  deleteBillableItem: () => deleteBillableItem4,
  getBillableItem: () => getBillableItem4,
  onBillableItemCreated: () => onBillableItemCreated2,
  onBillableItemDeleted: () => onBillableItemDeleted2,
  onBillableItemUpdated: () => onBillableItemUpdated2,
  queryBillableItems: () => queryBillableItems4,
  searchBillableItems: () => searchBillableItems4,
  updateBillableItem: () => updateBillableItem4
});
module.exports = __toCommonJS(index_exports);

// src/billable-items-v1-billable-item-billable-items.public.ts
var import_rename_all_nested_keys2 = require("@wix/sdk-runtime/rename-all-nested-keys");
var import_image3 = require("@wix/sdk-runtime/transformations/image");
var import_timestamp3 = require("@wix/sdk-runtime/transformations/timestamp");
var import_transform_paths3 = require("@wix/sdk-runtime/transformations/transform-paths");
var import_sdk_types = require("@wix/sdk-types");

// src/billable-items-v1-billable-item-billable-items.universal.ts
var import_transform_error = require("@wix/sdk-runtime/transform-error");
var import_query_builder = require("@wix/sdk-runtime/query-builder");
var import_rename_all_nested_keys = require("@wix/sdk-runtime/rename-all-nested-keys");

// src/billable-items-v1-billable-item-billable-items.http.ts
var import_rest_modules = require("@wix/sdk-runtime/rest-modules");
var import_float = require("@wix/sdk-runtime/transformations/float");
var import_float2 = require("@wix/sdk-runtime/transformations/float");
var import_timestamp = require("@wix/sdk-runtime/transformations/timestamp");
var import_timestamp2 = require("@wix/sdk-runtime/transformations/timestamp");
var import_field_mask = require("@wix/sdk-runtime/transformations/field-mask");
var import_transform_paths = require("@wix/sdk-runtime/transformations/transform-paths");
var import_rest_modules2 = require("@wix/sdk-runtime/rest-modules");
function resolveWixBillableItemsV1BillableItemsUrl(opts) {
  const domainToMappings = {
    "manage._base_domain_": [
      {
        srcPath: "/_api/billable-items",
        destPath: ""
      }
    ],
    "www.wixapis.com": [
      {
        srcPath: "/billable-items/v1/billable-items",
        destPath: "/v1/billable-items"
      }
    ]
  };
  return (0, import_rest_modules2.resolveUrl)(Object.assign(opts, { domainToMappings }));
}
var PACKAGE_NAME = "@wix/auto_sdk_get-paid_billable-items";
function createBillableItem(payload) {
  function __createBillableItem({ host }) {
    const serializedData = (0, import_transform_paths.transformPaths)(payload, [
      {
        transformFn: import_timestamp.transformSDKTimestampToRESTTimestamp,
        paths: [
          { path: "billableItem.createdDate" },
          { path: "billableItem.updatedDate" }
        ]
      }
    ]);
    const metadata = {
      entityFqdn: "wix.billable_items.v1.billable_item",
      method: "POST",
      methodFqn: "wix.billable_items.v1.BillableItems.CreateBillableItem",
      packageName: PACKAGE_NAME,
      url: resolveWixBillableItemsV1BillableItemsUrl({
        protoPath: "/v1/billable-items",
        data: serializedData,
        host
      }),
      data: serializedData,
      transformResponse: (payload2) => (0, import_transform_paths.transformPaths)(payload2, [
        {
          transformFn: import_timestamp2.transformRESTTimestampToSDKTimestamp,
          paths: [
            { path: "billableItem.createdDate" },
            { path: "billableItem.updatedDate" }
          ]
        }
      ])
    };
    return metadata;
  }
  return __createBillableItem;
}
function getBillableItem(payload) {
  function __getBillableItem({ host }) {
    const metadata = {
      entityFqdn: "wix.billable_items.v1.billable_item",
      method: "GET",
      methodFqn: "wix.billable_items.v1.BillableItems.GetBillableItem",
      packageName: PACKAGE_NAME,
      url: resolveWixBillableItemsV1BillableItemsUrl({
        protoPath: "/v1/billable-items/{billableItemId}",
        data: payload,
        host
      }),
      params: (0, import_rest_modules.toURLSearchParams)(payload),
      transformResponse: (payload2) => (0, import_transform_paths.transformPaths)(payload2, [
        {
          transformFn: import_timestamp2.transformRESTTimestampToSDKTimestamp,
          paths: [
            { path: "billableItem.createdDate" },
            { path: "billableItem.updatedDate" }
          ]
        }
      ])
    };
    return metadata;
  }
  return __getBillableItem;
}
function updateBillableItem(payload) {
  function __updateBillableItem({ host }) {
    const serializedData = (0, import_transform_paths.transformPaths)(payload, [
      {
        transformFn: import_field_mask.transformSDKFieldMaskToRESTFieldMask,
        paths: [{ path: "fieldMask" }]
      },
      {
        transformFn: import_timestamp.transformSDKTimestampToRESTTimestamp,
        paths: [
          { path: "billableItem.createdDate" },
          { path: "billableItem.updatedDate" }
        ]
      }
    ]);
    const metadata = {
      entityFqdn: "wix.billable_items.v1.billable_item",
      method: "PATCH",
      methodFqn: "wix.billable_items.v1.BillableItems.UpdateBillableItem",
      packageName: PACKAGE_NAME,
      url: resolveWixBillableItemsV1BillableItemsUrl({
        protoPath: "/v1/billable-items/{billableItem.id}",
        data: serializedData,
        host
      }),
      data: serializedData,
      transformResponse: (payload2) => (0, import_transform_paths.transformPaths)(payload2, [
        {
          transformFn: import_timestamp2.transformRESTTimestampToSDKTimestamp,
          paths: [
            { path: "billableItem.createdDate" },
            { path: "billableItem.updatedDate" }
          ]
        }
      ])
    };
    return metadata;
  }
  return __updateBillableItem;
}
function deleteBillableItem(payload) {
  function __deleteBillableItem({ host }) {
    const metadata = {
      entityFqdn: "wix.billable_items.v1.billable_item",
      method: "DELETE",
      methodFqn: "wix.billable_items.v1.BillableItems.DeleteBillableItem",
      packageName: PACKAGE_NAME,
      url: resolveWixBillableItemsV1BillableItemsUrl({
        protoPath: "/v1/billable-items/{billableItemId}",
        data: payload,
        host
      }),
      params: (0, import_rest_modules.toURLSearchParams)(payload)
    };
    return metadata;
  }
  return __deleteBillableItem;
}
function queryBillableItems(payload) {
  function __queryBillableItems({ host }) {
    const metadata = {
      entityFqdn: "wix.billable_items.v1.billable_item",
      method: "POST",
      methodFqn: "wix.billable_items.v1.BillableItems.QueryBillableItems",
      packageName: PACKAGE_NAME,
      url: resolveWixBillableItemsV1BillableItemsUrl({
        protoPath: "/v1/billable-items/query",
        data: payload,
        host
      }),
      data: payload,
      transformResponse: (payload2) => (0, import_transform_paths.transformPaths)(payload2, [
        {
          transformFn: import_timestamp2.transformRESTTimestampToSDKTimestamp,
          paths: [
            { path: "billableItems.createdDate" },
            { path: "billableItems.updatedDate" }
          ]
        }
      ]),
      fallback: [
        {
          method: "POST",
          url: resolveWixBillableItemsV1BillableItemsUrl({
            protoPath: "/v1/billable-items/query",
            data: payload,
            host
          }),
          data: payload
        }
      ]
    };
    return metadata;
  }
  return __queryBillableItems;
}
function bulkCreateBillableItems(payload) {
  function __bulkCreateBillableItems({ host }) {
    const serializedData = (0, import_transform_paths.transformPaths)(payload, [
      {
        transformFn: import_timestamp.transformSDKTimestampToRESTTimestamp,
        paths: [
          { path: "billableItems.createdDate" },
          { path: "billableItems.updatedDate" }
        ]
      }
    ]);
    const metadata = {
      entityFqdn: "wix.billable_items.v1.billable_item",
      method: "POST",
      methodFqn: "wix.billable_items.v1.BillableItems.BulkCreateBillableItems",
      packageName: PACKAGE_NAME,
      url: resolveWixBillableItemsV1BillableItemsUrl({
        protoPath: "/v1/bulk/billable-items/create",
        data: serializedData,
        host
      }),
      data: serializedData,
      transformResponse: (payload2) => (0, import_transform_paths.transformPaths)(payload2, [
        {
          transformFn: import_timestamp2.transformRESTTimestampToSDKTimestamp,
          paths: [
            { path: "results.item.createdDate" },
            { path: "results.item.updatedDate" }
          ]
        }
      ])
    };
    return metadata;
  }
  return __bulkCreateBillableItems;
}
function bulkUpdateBillableItems(payload) {
  function __bulkUpdateBillableItems({ host }) {
    const serializedData = (0, import_transform_paths.transformPaths)(payload, [
      {
        transformFn: import_field_mask.transformSDKFieldMaskToRESTFieldMask,
        paths: [{ path: "billableItems.fieldMask" }]
      },
      {
        transformFn: import_timestamp.transformSDKTimestampToRESTTimestamp,
        paths: [
          { path: "billableItems.billableItem.createdDate" },
          { path: "billableItems.billableItem.updatedDate" }
        ]
      }
    ]);
    const metadata = {
      entityFqdn: "wix.billable_items.v1.billable_item",
      method: "POST",
      methodFqn: "wix.billable_items.v1.BillableItems.BulkUpdateBillableItems",
      packageName: PACKAGE_NAME,
      url: resolveWixBillableItemsV1BillableItemsUrl({
        protoPath: "/v1/bulk/billable-items/update",
        data: serializedData,
        host
      }),
      data: serializedData,
      transformResponse: (payload2) => (0, import_transform_paths.transformPaths)(payload2, [
        {
          transformFn: import_timestamp2.transformRESTTimestampToSDKTimestamp,
          paths: [
            { path: "results.item.createdDate" },
            { path: "results.item.updatedDate" }
          ]
        }
      ])
    };
    return metadata;
  }
  return __bulkUpdateBillableItems;
}
function bulkDeleteBillableItems(payload) {
  function __bulkDeleteBillableItems({ host }) {
    const metadata = {
      entityFqdn: "wix.billable_items.v1.billable_item",
      method: "POST",
      methodFqn: "wix.billable_items.v1.BillableItems.BulkDeleteBillableItems",
      packageName: PACKAGE_NAME,
      url: resolveWixBillableItemsV1BillableItemsUrl({
        protoPath: "/v1/bulk/billable-items/delete",
        data: payload,
        host
      }),
      data: payload
    };
    return metadata;
  }
  return __bulkDeleteBillableItems;
}
function bulkUpdateBillableItemTags(payload) {
  function __bulkUpdateBillableItemTags({ host }) {
    const metadata = {
      entityFqdn: "wix.billable_items.v1.billable_item",
      method: "POST",
      methodFqn: "wix.billable_items.v1.BillableItems.BulkUpdateBillableItemTags",
      packageName: PACKAGE_NAME,
      url: resolveWixBillableItemsV1BillableItemsUrl({
        protoPath: "/v1/bulk/billable-items/update-tags",
        data: payload,
        host
      }),
      data: payload
    };
    return metadata;
  }
  return __bulkUpdateBillableItemTags;
}
function bulkUpdateBillableItemTagsByFilter(payload) {
  function __bulkUpdateBillableItemTagsByFilter({ host }) {
    const metadata = {
      entityFqdn: "wix.billable_items.v1.billable_item",
      method: "POST",
      methodFqn: "wix.billable_items.v1.BillableItems.BulkUpdateBillableItemTagsByFilter",
      packageName: PACKAGE_NAME,
      url: resolveWixBillableItemsV1BillableItemsUrl({
        protoPath: "/v1/bulk/billable-items/update-tags-by-filter",
        data: payload,
        host
      }),
      data: payload
    };
    return metadata;
  }
  return __bulkUpdateBillableItemTagsByFilter;
}
function searchBillableItems(payload) {
  function __searchBillableItems({ host }) {
    const serializedData = (0, import_transform_paths.transformPaths)(payload, [
      {
        transformFn: import_float.transformSDKFloatToRESTFloat,
        paths: [
          { path: "search.aggregations.range.buckets.from" },
          { path: "search.aggregations.range.buckets.to" },
          {
            path: "search.aggregations.nested.nestedAggregations.range.buckets.from"
          },
          {
            path: "search.aggregations.nested.nestedAggregations.range.buckets.to"
          }
        ]
      }
    ]);
    const metadata = {
      entityFqdn: "wix.billable_items.v1.billable_item",
      method: "POST",
      methodFqn: "wix.billable_items.v1.BillableItems.SearchBillableItems",
      packageName: PACKAGE_NAME,
      url: resolveWixBillableItemsV1BillableItemsUrl({
        protoPath: "/v1/billable-items/search",
        data: serializedData,
        host
      }),
      data: serializedData,
      transformResponse: (payload2) => (0, import_transform_paths.transformPaths)(payload2, [
        {
          transformFn: import_timestamp2.transformRESTTimestampToSDKTimestamp,
          paths: [
            { path: "billableItems.createdDate" },
            { path: "billableItems.updatedDate" }
          ]
        },
        {
          transformFn: import_float2.transformRESTFloatToSDKFloat,
          paths: [
            { path: "aggregationData.results.ranges.results.from" },
            { path: "aggregationData.results.ranges.results.to" },
            {
              path: "aggregationData.results.groupedByValue.results.nestedResults.ranges.results.from"
            },
            {
              path: "aggregationData.results.groupedByValue.results.nestedResults.ranges.results.to"
            },
            {
              path: "aggregationData.results.nested.results.results.*.range.from"
            },
            {
              path: "aggregationData.results.nested.results.results.*.range.to"
            },
            { path: "aggregationData.results.scalar.value" },
            {
              path: "aggregationData.results.groupedByValue.results.nestedResults.scalar.value"
            },
            {
              path: "aggregationData.results.nested.results.results.*.scalar.value"
            }
          ]
        }
      ])
    };
    return metadata;
  }
  return __searchBillableItems;
}

// src/billable-items-v1-billable-item-billable-items.universal.ts
var import_image = require("@wix/sdk-runtime/transformations/image");
var import_image2 = require("@wix/sdk-runtime/transformations/image");
var import_transform_paths2 = require("@wix/sdk-runtime/transformations/transform-paths");
var WebhookIdentityType = /* @__PURE__ */ ((WebhookIdentityType2) => {
  WebhookIdentityType2["UNKNOWN"] = "UNKNOWN";
  WebhookIdentityType2["ANONYMOUS_VISITOR"] = "ANONYMOUS_VISITOR";
  WebhookIdentityType2["MEMBER"] = "MEMBER";
  WebhookIdentityType2["WIX_USER"] = "WIX_USER";
  WebhookIdentityType2["APP"] = "APP";
  return WebhookIdentityType2;
})(WebhookIdentityType || {});
var SortOrder = /* @__PURE__ */ ((SortOrder2) => {
  SortOrder2["ASC"] = "ASC";
  SortOrder2["DESC"] = "DESC";
  return SortOrder2;
})(SortOrder || {});
var SortType = /* @__PURE__ */ ((SortType2) => {
  SortType2["COUNT"] = "COUNT";
  SortType2["VALUE"] = "VALUE";
  return SortType2;
})(SortType || {});
var SortDirection = /* @__PURE__ */ ((SortDirection2) => {
  SortDirection2["DESC"] = "DESC";
  SortDirection2["ASC"] = "ASC";
  return SortDirection2;
})(SortDirection || {});
var MissingValues = /* @__PURE__ */ ((MissingValues2) => {
  MissingValues2["EXCLUDE"] = "EXCLUDE";
  MissingValues2["INCLUDE"] = "INCLUDE";
  return MissingValues2;
})(MissingValues || {});
var ScalarType = /* @__PURE__ */ ((ScalarType2) => {
  ScalarType2["UNKNOWN_SCALAR_TYPE"] = "UNKNOWN_SCALAR_TYPE";
  ScalarType2["COUNT_DISTINCT"] = "COUNT_DISTINCT";
  ScalarType2["MIN"] = "MIN";
  ScalarType2["MAX"] = "MAX";
  return ScalarType2;
})(ScalarType || {});
var NestedAggregationType = /* @__PURE__ */ ((NestedAggregationType2) => {
  NestedAggregationType2["UNKNOWN_AGGREGATION_TYPE"] = "UNKNOWN_AGGREGATION_TYPE";
  NestedAggregationType2["VALUE"] = "VALUE";
  NestedAggregationType2["RANGE"] = "RANGE";
  NestedAggregationType2["SCALAR"] = "SCALAR";
  NestedAggregationType2["DATE_HISTOGRAM"] = "DATE_HISTOGRAM";
  return NestedAggregationType2;
})(NestedAggregationType || {});
var Interval = /* @__PURE__ */ ((Interval2) => {
  Interval2["UNKNOWN_INTERVAL"] = "UNKNOWN_INTERVAL";
  Interval2["YEAR"] = "YEAR";
  Interval2["MONTH"] = "MONTH";
  Interval2["WEEK"] = "WEEK";
  Interval2["DAY"] = "DAY";
  Interval2["HOUR"] = "HOUR";
  Interval2["MINUTE"] = "MINUTE";
  Interval2["SECOND"] = "SECOND";
  return Interval2;
})(Interval || {});
var AggregationType = /* @__PURE__ */ ((AggregationType2) => {
  AggregationType2["UNKNOWN_AGGREGATION_TYPE"] = "UNKNOWN_AGGREGATION_TYPE";
  AggregationType2["VALUE"] = "VALUE";
  AggregationType2["RANGE"] = "RANGE";
  AggregationType2["SCALAR"] = "SCALAR";
  AggregationType2["DATE_HISTOGRAM"] = "DATE_HISTOGRAM";
  AggregationType2["NESTED"] = "NESTED";
  return AggregationType2;
})(AggregationType || {});
var Mode = /* @__PURE__ */ ((Mode2) => {
  Mode2["OR"] = "OR";
  Mode2["AND"] = "AND";
  return Mode2;
})(Mode || {});
async function createBillableItem2(billableItem) {
  const { httpClient, sideEffects } = arguments[1];
  const payload = (0, import_transform_paths2.transformPaths)(
    (0, import_rename_all_nested_keys.renameKeysFromSDKRequestToRESTRequest)({ billableItem }),
    [
      {
        transformFn: import_image.transformSDKImageToRESTImage,
        paths: [{ path: "billableItem.image" }]
      }
    ]
  );
  const reqOpts = createBillableItem(payload);
  sideEffects?.onSiteCall?.();
  try {
    const result = await httpClient.request(reqOpts);
    sideEffects?.onSuccess?.(result);
    return (0, import_rename_all_nested_keys.renameKeysFromRESTResponseToSDKResponse)(
      (0, import_transform_paths2.transformPaths)(result.data, [
        {
          transformFn: import_image2.transformRESTImageToSDKImage,
          paths: [{ path: "billableItem.image" }]
        }
      ])
    )?.billableItem;
  } catch (err) {
    const transformedError = (0, import_transform_error.transformError)(
      err,
      {
        spreadPathsToArguments: {},
        explicitPathsToArguments: { billableItem: "$[0]" },
        singleArgumentUnchanged: false
      },
      ["billableItem"]
    );
    sideEffects?.onError?.(err);
    throw transformedError;
  }
}
async function getBillableItem2(billableItemId) {
  const { httpClient, sideEffects } = arguments[1];
  const payload = (0, import_rename_all_nested_keys.renameKeysFromSDKRequestToRESTRequest)({
    billableItemId
  });
  const reqOpts = getBillableItem(payload);
  sideEffects?.onSiteCall?.();
  try {
    const result = await httpClient.request(reqOpts);
    sideEffects?.onSuccess?.(result);
    return (0, import_rename_all_nested_keys.renameKeysFromRESTResponseToSDKResponse)(
      (0, import_transform_paths2.transformPaths)(result.data, [
        {
          transformFn: import_image2.transformRESTImageToSDKImage,
          paths: [{ path: "billableItem.image" }]
        }
      ])
    )?.billableItem;
  } catch (err) {
    const transformedError = (0, import_transform_error.transformError)(
      err,
      {
        spreadPathsToArguments: {},
        explicitPathsToArguments: { billableItemId: "$[0]" },
        singleArgumentUnchanged: false
      },
      ["billableItemId"]
    );
    sideEffects?.onError?.(err);
    throw transformedError;
  }
}
async function updateBillableItem2(_id, billableItem) {
  const { httpClient, sideEffects } = arguments[2];
  const payload = (0, import_transform_paths2.transformPaths)(
    (0, import_rename_all_nested_keys.renameKeysFromSDKRequestToRESTRequest)({
      billableItem: { ...billableItem, id: _id }
    }),
    [
      {
        transformFn: import_image.transformSDKImageToRESTImage,
        paths: [{ path: "billableItem.image" }]
      }
    ]
  );
  const reqOpts = updateBillableItem(payload);
  sideEffects?.onSiteCall?.();
  try {
    const result = await httpClient.request(reqOpts);
    sideEffects?.onSuccess?.(result);
    return (0, import_rename_all_nested_keys.renameKeysFromRESTResponseToSDKResponse)(
      (0, import_transform_paths2.transformPaths)(result.data, [
        {
          transformFn: import_image2.transformRESTImageToSDKImage,
          paths: [{ path: "billableItem.image" }]
        }
      ])
    )?.billableItem;
  } catch (err) {
    const transformedError = (0, import_transform_error.transformError)(
      err,
      {
        spreadPathsToArguments: { billableItem: "$[1]" },
        explicitPathsToArguments: { "billableItem.id": "$[0]" },
        singleArgumentUnchanged: false
      },
      ["_id", "billableItem"]
    );
    sideEffects?.onError?.(err);
    throw transformedError;
  }
}
async function deleteBillableItem2(billableItemId) {
  const { httpClient, sideEffects } = arguments[1];
  const payload = (0, import_rename_all_nested_keys.renameKeysFromSDKRequestToRESTRequest)({
    billableItemId
  });
  const reqOpts = deleteBillableItem(payload);
  sideEffects?.onSiteCall?.();
  try {
    const result = await httpClient.request(reqOpts);
    sideEffects?.onSuccess?.(result);
  } catch (err) {
    const transformedError = (0, import_transform_error.transformError)(
      err,
      {
        spreadPathsToArguments: {},
        explicitPathsToArguments: { billableItemId: "$[0]" },
        singleArgumentUnchanged: false
      },
      ["billableItemId"]
    );
    sideEffects?.onError?.(err);
    throw transformedError;
  }
}
function queryBillableItems2() {
  const { httpClient, sideEffects } = arguments[0];
  return (0, import_query_builder.queryBuilder)({
    func: async (payload) => {
      const reqOpts = queryBillableItems(payload);
      sideEffects?.onSiteCall?.();
      try {
        const result = await httpClient.request(reqOpts);
        sideEffects?.onSuccess?.(result);
        return result;
      } catch (err) {
        sideEffects?.onError?.(err);
        throw err;
      }
    },
    requestTransformer: (query) => {
      const args = [query, {}];
      return (0, import_rename_all_nested_keys.renameKeysFromSDKRequestToRESTRequest)({
        ...args?.[1],
        query: args?.[0]
      });
    },
    responseTransformer: ({
      data
    }) => {
      const transformedData = (0, import_rename_all_nested_keys.renameKeysFromRESTResponseToSDKResponse)(
        (0, import_transform_paths2.transformPaths)(data, [
          {
            transformFn: import_image2.transformRESTImageToSDKImage,
            paths: [{ path: "billableItems.image" }]
          }
        ])
      );
      return {
        items: transformedData?.billableItems,
        pagingMetadata: transformedData?.pagingMetadata
      };
    },
    errorTransformer: (err) => {
      const transformedError = (0, import_transform_error.transformError)(err, {
        spreadPathsToArguments: {},
        explicitPathsToArguments: { query: "$[0]" },
        singleArgumentUnchanged: false
      });
      throw transformedError;
    },
    pagingMethod: "CURSOR",
    transformationPaths: {}
  });
}
async function bulkCreateBillableItems2(billableItems, options) {
  const { httpClient, sideEffects } = arguments[2];
  const payload = (0, import_transform_paths2.transformPaths)(
    (0, import_rename_all_nested_keys.renameKeysFromSDKRequestToRESTRequest)({
      billableItems,
      returnEntity: options?.returnEntity
    }),
    [
      {
        transformFn: import_image.transformSDKImageToRESTImage,
        paths: [{ path: "billableItems.image" }]
      }
    ]
  );
  const reqOpts = bulkCreateBillableItems(payload);
  sideEffects?.onSiteCall?.();
  try {
    const result = await httpClient.request(reqOpts);
    sideEffects?.onSuccess?.(result);
    return (0, import_rename_all_nested_keys.renameKeysFromRESTResponseToSDKResponse)(
      (0, import_transform_paths2.transformPaths)(result.data, [
        {
          transformFn: import_image2.transformRESTImageToSDKImage,
          paths: [{ path: "results.item.image" }]
        }
      ])
    );
  } catch (err) {
    const transformedError = (0, import_transform_error.transformError)(
      err,
      {
        spreadPathsToArguments: {},
        explicitPathsToArguments: {
          billableItems: "$[0]",
          returnEntity: "$[1].returnEntity"
        },
        singleArgumentUnchanged: false
      },
      ["billableItems", "options"]
    );
    sideEffects?.onError?.(err);
    throw transformedError;
  }
}
async function bulkUpdateBillableItems2(billableItems, options) {
  const { httpClient, sideEffects } = arguments[2];
  const payload = (0, import_transform_paths2.transformPaths)(
    (0, import_rename_all_nested_keys.renameKeysFromSDKRequestToRESTRequest)({
      billableItems,
      returnEntity: options?.returnEntity
    }),
    [
      {
        transformFn: import_image.transformSDKImageToRESTImage,
        paths: [{ path: "billableItems.billableItem.image" }]
      }
    ]
  );
  const reqOpts = bulkUpdateBillableItems(payload);
  sideEffects?.onSiteCall?.();
  try {
    const result = await httpClient.request(reqOpts);
    sideEffects?.onSuccess?.(result);
    return (0, import_rename_all_nested_keys.renameKeysFromRESTResponseToSDKResponse)(
      (0, import_transform_paths2.transformPaths)(result.data, [
        {
          transformFn: import_image2.transformRESTImageToSDKImage,
          paths: [{ path: "results.item.image" }]
        }
      ])
    );
  } catch (err) {
    const transformedError = (0, import_transform_error.transformError)(
      err,
      {
        spreadPathsToArguments: {},
        explicitPathsToArguments: {
          billableItems: "$[0]",
          returnEntity: "$[1].returnEntity"
        },
        singleArgumentUnchanged: false
      },
      ["billableItems", "options"]
    );
    sideEffects?.onError?.(err);
    throw transformedError;
  }
}
async function bulkDeleteBillableItems2(billableItemIds) {
  const { httpClient, sideEffects } = arguments[1];
  const payload = (0, import_rename_all_nested_keys.renameKeysFromSDKRequestToRESTRequest)({
    billableItemIds
  });
  const reqOpts = bulkDeleteBillableItems(payload);
  sideEffects?.onSiteCall?.();
  try {
    const result = await httpClient.request(reqOpts);
    sideEffects?.onSuccess?.(result);
    return (0, import_rename_all_nested_keys.renameKeysFromRESTResponseToSDKResponse)(result.data);
  } catch (err) {
    const transformedError = (0, import_transform_error.transformError)(
      err,
      {
        spreadPathsToArguments: {},
        explicitPathsToArguments: { billableItemIds: "$[0]" },
        singleArgumentUnchanged: false
      },
      ["billableItemIds"]
    );
    sideEffects?.onError?.(err);
    throw transformedError;
  }
}
async function bulkUpdateBillableItemTags2(billableItemIds, options) {
  const { httpClient, sideEffects } = arguments[2];
  const payload = (0, import_rename_all_nested_keys.renameKeysFromSDKRequestToRESTRequest)({
    billableItemIds,
    assignTags: options?.assignTags,
    unassignTags: options?.unassignTags
  });
  const reqOpts = bulkUpdateBillableItemTags(
    payload
  );
  sideEffects?.onSiteCall?.();
  try {
    const result = await httpClient.request(reqOpts);
    sideEffects?.onSuccess?.(result);
    return (0, import_rename_all_nested_keys.renameKeysFromRESTResponseToSDKResponse)(result.data);
  } catch (err) {
    const transformedError = (0, import_transform_error.transformError)(
      err,
      {
        spreadPathsToArguments: {},
        explicitPathsToArguments: {
          billableItemIds: "$[0]",
          assignTags: "$[1].assignTags",
          unassignTags: "$[1].unassignTags"
        },
        singleArgumentUnchanged: false
      },
      ["billableItemIds", "options"]
    );
    sideEffects?.onError?.(err);
    throw transformedError;
  }
}
async function bulkUpdateBillableItemTagsByFilter2(filter, options) {
  const { httpClient, sideEffects } = arguments[2];
  const payload = (0, import_rename_all_nested_keys.renameKeysFromSDKRequestToRESTRequest)({
    filter,
    assignTags: options?.assignTags,
    unassignTags: options?.unassignTags
  });
  const reqOpts = bulkUpdateBillableItemTagsByFilter(
    payload
  );
  sideEffects?.onSiteCall?.();
  try {
    const result = await httpClient.request(reqOpts);
    sideEffects?.onSuccess?.(result);
    return (0, import_rename_all_nested_keys.renameKeysFromRESTResponseToSDKResponse)(result.data);
  } catch (err) {
    const transformedError = (0, import_transform_error.transformError)(
      err,
      {
        spreadPathsToArguments: {},
        explicitPathsToArguments: {
          filter: "$[0]",
          assignTags: "$[1].assignTags",
          unassignTags: "$[1].unassignTags"
        },
        singleArgumentUnchanged: false
      },
      ["filter", "options"]
    );
    sideEffects?.onError?.(err);
    throw transformedError;
  }
}
async function searchBillableItems2(search) {
  const { httpClient, sideEffects } = arguments[1];
  const payload = (0, import_rename_all_nested_keys.renameKeysFromSDKRequestToRESTRequest)({ search });
  const reqOpts = searchBillableItems(payload);
  sideEffects?.onSiteCall?.();
  try {
    const result = await httpClient.request(reqOpts);
    sideEffects?.onSuccess?.(result);
    return (0, import_rename_all_nested_keys.renameKeysFromRESTResponseToSDKResponse)(
      (0, import_transform_paths2.transformPaths)(result.data, [
        {
          transformFn: import_image2.transformRESTImageToSDKImage,
          paths: [{ path: "billableItems.image" }]
        }
      ])
    );
  } catch (err) {
    const transformedError = (0, import_transform_error.transformError)(
      err,
      {
        spreadPathsToArguments: {},
        explicitPathsToArguments: { search: "$[0]" },
        singleArgumentUnchanged: false
      },
      ["search"]
    );
    sideEffects?.onError?.(err);
    throw transformedError;
  }
}

// src/billable-items-v1-billable-item-billable-items.public.ts
function createBillableItem3(httpClient) {
  return (billableItem) => createBillableItem2(
    billableItem,
    // @ts-ignore
    { httpClient }
  );
}
function getBillableItem3(httpClient) {
  return (billableItemId) => getBillableItem2(
    billableItemId,
    // @ts-ignore
    { httpClient }
  );
}
function updateBillableItem3(httpClient) {
  return (_id, billableItem) => updateBillableItem2(
    _id,
    billableItem,
    // @ts-ignore
    { httpClient }
  );
}
function deleteBillableItem3(httpClient) {
  return (billableItemId) => deleteBillableItem2(
    billableItemId,
    // @ts-ignore
    { httpClient }
  );
}
function queryBillableItems3(httpClient) {
  return () => queryBillableItems2(
    // @ts-ignore
    { httpClient }
  );
}
function bulkCreateBillableItems3(httpClient) {
  return (billableItems, options) => bulkCreateBillableItems2(
    billableItems,
    options,
    // @ts-ignore
    { httpClient }
  );
}
function bulkUpdateBillableItems3(httpClient) {
  return (billableItems, options) => bulkUpdateBillableItems2(
    billableItems,
    options,
    // @ts-ignore
    { httpClient }
  );
}
function bulkDeleteBillableItems3(httpClient) {
  return (billableItemIds) => bulkDeleteBillableItems2(
    billableItemIds,
    // @ts-ignore
    { httpClient }
  );
}
function bulkUpdateBillableItemTags3(httpClient) {
  return (billableItemIds, options) => bulkUpdateBillableItemTags2(
    billableItemIds,
    options,
    // @ts-ignore
    { httpClient }
  );
}
function bulkUpdateBillableItemTagsByFilter3(httpClient) {
  return (filter, options) => bulkUpdateBillableItemTagsByFilter2(
    filter,
    options,
    // @ts-ignore
    { httpClient }
  );
}
function searchBillableItems3(httpClient) {
  return (search) => searchBillableItems2(
    search,
    // @ts-ignore
    { httpClient }
  );
}
var onBillableItemCreated = (0, import_sdk_types.EventDefinition)(
  "wix.billable_items.v1.billable_item_created",
  true,
  (event) => (0, import_rename_all_nested_keys2.renameKeysFromRESTResponseToSDKResponse)(
    (0, import_transform_paths3.transformPaths)(event, [
      {
        transformFn: import_timestamp3.transformRESTTimestampToSDKTimestamp,
        paths: [
          { path: "entity.createdDate" },
          { path: "entity.updatedDate" },
          { path: "metadata.eventTime" }
        ]
      },
      {
        transformFn: import_image3.transformRESTImageToSDKImage,
        paths: [{ path: "entity.image" }]
      }
    ])
  )
)();
var onBillableItemDeleted = (0, import_sdk_types.EventDefinition)(
  "wix.billable_items.v1.billable_item_deleted",
  true,
  (event) => (0, import_rename_all_nested_keys2.renameKeysFromRESTResponseToSDKResponse)(
    (0, import_transform_paths3.transformPaths)(event, [
      {
        transformFn: import_timestamp3.transformRESTTimestampToSDKTimestamp,
        paths: [
          { path: "entity.createdDate" },
          { path: "entity.updatedDate" },
          { path: "metadata.eventTime" }
        ]
      },
      {
        transformFn: import_image3.transformRESTImageToSDKImage,
        paths: [{ path: "entity.image" }]
      }
    ])
  )
)();
var onBillableItemUpdated = (0, import_sdk_types.EventDefinition)(
  "wix.billable_items.v1.billable_item_updated",
  true,
  (event) => (0, import_rename_all_nested_keys2.renameKeysFromRESTResponseToSDKResponse)(
    (0, import_transform_paths3.transformPaths)(event, [
      {
        transformFn: import_timestamp3.transformRESTTimestampToSDKTimestamp,
        paths: [
          { path: "entity.createdDate" },
          { path: "entity.updatedDate" },
          { path: "metadata.eventTime" }
        ]
      },
      {
        transformFn: import_image3.transformRESTImageToSDKImage,
        paths: [{ path: "entity.image" }]
      }
    ])
  )
)();

// src/billable-items-v1-billable-item-billable-items.context.ts
var import_rest_modules3 = require("@wix/sdk-runtime/rest-modules");
var import_event_definition_modules = require("@wix/sdk-runtime/event-definition-modules");
var createBillableItem4 = /* @__PURE__ */ (0, import_rest_modules3.createRESTModule)(createBillableItem3);
var getBillableItem4 = /* @__PURE__ */ (0, import_rest_modules3.createRESTModule)(getBillableItem3);
var updateBillableItem4 = /* @__PURE__ */ (0, import_rest_modules3.createRESTModule)(updateBillableItem3);
var deleteBillableItem4 = /* @__PURE__ */ (0, import_rest_modules3.createRESTModule)(deleteBillableItem3);
var queryBillableItems4 = /* @__PURE__ */ (0, import_rest_modules3.createRESTModule)(queryBillableItems3);
var bulkCreateBillableItems4 = /* @__PURE__ */ (0, import_rest_modules3.createRESTModule)(bulkCreateBillableItems3);
var bulkUpdateBillableItems4 = /* @__PURE__ */ (0, import_rest_modules3.createRESTModule)(bulkUpdateBillableItems3);
var bulkDeleteBillableItems4 = /* @__PURE__ */ (0, import_rest_modules3.createRESTModule)(bulkDeleteBillableItems3);
var bulkUpdateBillableItemTags4 = /* @__PURE__ */ (0, import_rest_modules3.createRESTModule)(bulkUpdateBillableItemTags3);
var bulkUpdateBillableItemTagsByFilter4 = /* @__PURE__ */ (0, import_rest_modules3.createRESTModule)(bulkUpdateBillableItemTagsByFilter3);
var searchBillableItems4 = /* @__PURE__ */ (0, import_rest_modules3.createRESTModule)(searchBillableItems3);
var onBillableItemCreated2 = (0, import_event_definition_modules.createEventModule)(onBillableItemCreated);
var onBillableItemDeleted2 = (0, import_event_definition_modules.createEventModule)(onBillableItemDeleted);
var onBillableItemUpdated2 = (0, import_event_definition_modules.createEventModule)(onBillableItemUpdated);
// Annotate the CommonJS export names for ESM import in node:
0 && (module.exports = {
  AggregationType,
  Interval,
  MissingValues,
  Mode,
  NestedAggregationType,
  ScalarType,
  SortDirection,
  SortOrder,
  SortType,
  WebhookIdentityType,
  bulkCreateBillableItems,
  bulkDeleteBillableItems,
  bulkUpdateBillableItemTags,
  bulkUpdateBillableItemTagsByFilter,
  bulkUpdateBillableItems,
  createBillableItem,
  deleteBillableItem,
  getBillableItem,
  onBillableItemCreated,
  onBillableItemDeleted,
  onBillableItemUpdated,
  queryBillableItems,
  searchBillableItems,
  updateBillableItem
});
//# sourceMappingURL=index.js.map